package taobao

import (
	"crypto/md5"
	"encoding/hex"
	"fmt"
	"io/ioutil"
	"net/http"
	"net/url"
	"reflect"
	"sort"
	"strings"
	"time"
	"xiaoxiong/internal/global"
)

const TaobaoUrl = "http://gw.api.taobao.com/router/rest"

type TbkItemInfoGetRequest struct {
	CommonRequest
	Platform string `json:"platform"`
	NumIids  string `json:"num_iids"`
}

type CommonRequest struct {
	AppKey     string `json:"app_key"`
	V          string `json:"v"`
	Format     string `json:"format"`
	SignMethod string `json:"sign_method"`
	Method     string `json:"method"`
	Timestamp  string `json:"timestamp"`
	//PartnerId  string `json:"partner_id"`
	Sign string `json:"sign"`
}

func getPostData(c interface{}) (url.Values,url.Values) {
	t := reflect.TypeOf(c)
	v := reflect.ValueOf(c)

	res := url.Values{}
	get := url.Values{}
	for k := 0; k < t.NumField(); k++ {
		if _, ok := v.Field(k).Interface().(CommonRequest); ok {
			tt := reflect.TypeOf(v.Field(k).Interface())
			vv := reflect.ValueOf(v.Field(k).Interface())
			for kk := 0; kk < tt.NumField(); kk++ {
				if value, ok := vv.Field(kk).Interface().(string); ok {
					//res.Set(tt.Field(kk).Tag.Get("json"), value)
					get.Set(tt.Field(kk).Tag.Get("json"), value)
				}
			}
		} else {
			if value, ok := v.Field(k).Interface().(string); ok {
				res.Set(t.Field(k).Tag.Get("json"), value)
			}
		}
	}

	return res,get
}

func generateSign(c interface{}, appKeyType int8) string {
	t := reflect.TypeOf(c)
	v := reflect.ValueOf(c)

	m := make(map[string]interface{})
	for k := 0; k < t.NumField(); k++ {
		if _, ok := v.Field(k).Interface().(CommonRequest); ok {
			tt := reflect.TypeOf(v.Field(k).Interface())
			vv := reflect.ValueOf(v.Field(k).Interface())
			for kk := 0; kk < tt.NumField(); kk++ {
				m[tt.Field(kk).Tag.Get("json")] = vv.Field(kk).Interface()
			}
		} else {
			m[t.Field(k).Tag.Get("json")] = v.Field(k).Interface()
		}
	}

	var arr []string
	for k, _ := range m {
		arr = append(arr, k)
	}
	sort.Strings(arr)

	secret := "e835d91edfb5487125f754d831a02fba"
	str := secret
	for _, k := range arr {
		str += fmt.Sprintf("%s%s", k, m[k])
	}
	str += secret

	println(str)

	h := md5.New()
	h.Write([]byte(str))
	return strings.ToTitle(hex.EncodeToString(h.Sum(nil)))
}

func newTbkItemInfoGetRequest(itemId string, appKeyType int8) *TbkItemInfoGetRequest {
	c := newCommonRequest(appKeyType)

	r := &TbkItemInfoGetRequest{
		*c,
		"2",
		itemId,
	}

	r.Sign = generateSign(*r, appKeyType)

	return r
}

func newCommonRequest(appKeyType int8) *CommonRequest {
	r := &CommonRequest{}

	appKey := "25623446"
	r.AppKey = appKey
	r.V = "2.0"
	r.Format = "json"
	r.SignMethod = "md5"
	r.Method = "taobao.tbk.item.info.get"
	r.Timestamp = time.Now().Format("2006-01-02 15:04:05")

	return r
}

type TbkItemInfoGetResponse struct {
}

func ItemDetail(itemId string, appKeyType int8) (*TbkItemInfoGetResponse, error) {
	var err error

	req := newTbkItemInfoGetRequest(itemId, appKeyType)

	a := time.Now().Format("2006-01-02 15:04:05")

	println()
	println()
	sss := fmt.Sprintf("%s%s", "asdsad",a)
	println(sss)
	println()
	println()

	v,getV := getPostData(*req)

	println(v.Encode())
	println(getV.Encode())

	urlPath := TaobaoUrl + "?" + getV.Encode()


	println(urlPath)

	resp, err := http.PostForm(urlPath, v)
	defer func() {
		err = resp.Body.Close()
		if err != nil {
			global.Log.Info(fmt.Sprintf("resp close err %s", err.Error()))
		}
	}()

	body, _ := ioutil.ReadAll(resp.Body)

	//res := &ItemDetailData{}
	//_ = json.Unmarshal(body, res)

	fmt.Printf("%s", body)
	_ = err
	println()

	return nil, nil
}
